<template>
  <div class="card shadow" :class="type === 'dark' ? 'bg-default' : ''">
    <div
      class="card-header border-0"
      :class="type === 'dark' ? 'bg-transparent' : ''"
    >
      <div class="row align-items-center">
        <div class="col">
          <h3 class="mb-0" :class="type === 'dark' ? 'text-white' : ''">
            {{ title }}
          </h3>
        </div>
      </div>
    </div>

    <div class="table-responsive">
      <v-app id="inspire">
        <v-card>
          <v-data-table
            :headers="headers"
            :items="users"
            :items-per-page="10"
            class="elevation-1"
            :search="search"
            item-key="id"
          >
            <template v-slot:top>
              <v-toolbar flat>
                <v-row>
                  <v-col col="5">
                    <v-dialog v-model="dialog" max-width="500px">
                      <template v-slot:activator="{ on, attrs }">
                        <v-btn
                          color="primary"
                          dark
                          class="mb-2"
                          v-bind="attrs"
                          v-on="on"
                        >
                          New School
                        </v-btn>
                      </template>
                      <v-card>
                        <v-card-title>
                          <span class="headline">{{ formTitle }}</span>
                        </v-card-title>

                        <v-card-text>
                          <v-container>
                             <form>
                                <v-row>

                              <v-col cols="12" sm="12" md="12">
                                <v-text-field
                                  v-model="editedItem.name"
                                  label="Name"
                                  required
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12" sm="12" md="12">
                                <v-text-field
                                  v-model="editedItem.address"
                                  label="Address"
                                  required
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12" sm="12" md="12">
                                <v-text-field
                                  v-model="editedItem.time_study"
                                  label="Time Study"
                                  required
                                ></v-text-field>
                              </v-col>
                            </v-row>
                             </form>
                           
                          </v-container>
                        </v-card-text>

                        <v-card-actions>
                          <v-spacer></v-spacer>
                          <v-btn color="blue darken-1" text @click="close">
                            Cancel
                          </v-btn>
                          <v-btn color="blue darken-1" text @click="save">
                            Save
                          </v-btn>
                        </v-card-actions>
                      </v-card>
                    </v-dialog>
                  </v-col>
                  <v-col col="7">
                    <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-col>
                </v-row>
              </v-toolbar>
            </template>

            <template v-slot:[`item.actions`]="{ item }">
              <v-icon color="blue" small class="mr-2" @click="editItem(item)">
                mdi-pencil
              </v-icon>
              <v-icon color="red" small @click="deleteItem(item)">
                mdi-delete
              </v-icon>
            </template>
          </v-data-table>
        </v-card>
      </v-app>
    </div>

    <div
      class="card-footer d-flex justify-content-end"
      :class="type === 'dark' ? 'bg-transparent' : ''"
    ></div>
  </div>
</template>
<script>
export default {
  name: "projects-table",
  props: {
    type: {
      type: String,
    },
    title: String,
  },
  data() {
    return {
      search: "",
      singleExpand: false,
      dialog: false,
      roleList: ["superAdmin","admin","teacher","parents"],
      headers: [
        {
          text: "ID",
          align: "start",
          sortable: false,
          value: "id",
        },
        { text: "Username", value: "username" },
        { text: "Email", value: "email" },
        { text: "Roles", value: "type" },
        { text: "Actions", value: "actions", sortable: false },
      ],
      editedIndex: -1,
      editedItem: {
        id: "",
        name: "",
        address: "",
        time_study: "",
        students_of_school: "",
        cars_of_school: "",
        teacher_of_school: "",
      },
      defaultItem: {
        id: "",
        name: "",
        address: "",
        time_study: "",
        students_of_school: "",
        cars_of_school: "",
        teacher_of_school: "",
      },
      // sweetalert
      Toast: this.$swal.mixin({
        toast: true,
        position: "top-end",
        showConfirmButton: false,
        timer: 3000,
        timerProgressBar: true,
        didOpen: (toast) => {
          toast.addEventListener("mouseenter", this.$swal.stopTimer);
          toast.addEventListener("mouseleave", this.$swal.resumeTimer);
        },
      }),
    };
  },
  methods: {
    editItem(item) {
      this.editedIndex = this.schools.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },

    deleteItem(item) {
      const index = this.schools.indexOf(item);
      const idStudent = this.schools[index].id;
      this.$swal
        .fire({
          title: "Do you want to delete this student?",
          showDenyButton: true,
          showCancelButton: true,
          confirmButtonText: `Save`,
          denyButtonText: `Don't save`,
        })
        .then((result) => {
          /* Read more about isConfirmed, isDenied below */
          if (result.isConfirmed) {
            this.$swal.fire("Deleted success!", "", "success");
            this.schools.splice(index, 1);
            this.$store.dispatch("student/deleteStudent", idStudent);
          } else if (result.isDenied) {
            this.$swal.fire("Cancel", "", "info");
          }
        });
    },

    close() {
      this.dialog = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    save() {
      const school = this.schools[this.editedIndex];
      if (this.editedIndex > -1) {
        Object.assign(this.schools[this.editedIndex], this.editedItem);
        this.$store
          .dispatch("school/editSchool", school)
          .then(() =>
            this.Toast.fire({
              icon: "success",
              title: "Edit school success !",
            })
          )
          .catch(() => {
            this.$swal.fire({
              icon: "error",
              title: "Oops...",
              text: "Something went wrong edit school !",
            });
          });
      } else {
        this.$store
          .dispatch("school/addSchool", this.editedItem)
          .then(() => {
            this.Toast.fire({
              icon: "success",
              title: "Add school success !",
            });
            this.schools.push(this.editedItem)
          })
          .catch(() => {
            this.$swal.fire({
              icon: "error",
              title: "Oops...",
              text: "Something went wrong create school !",
            });
          });
      }
      this.close();
    },
  },
  computed: {
    users() {
      return this.$store.state.user.users;
    },
    formTitle() {
      return this.editedIndex === -1 ? "New School" : "Edit School";
    },
  },
  watch: {
    dialog(val) {
      val || this.close();
    },
  },
  created() {
    this.$store.dispatch("user/fetch");
  },
};
</script>
<style>
</style>
